"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs/promises"));
const path_1 = require("path");
// @ts-expect-error no types installed
const fs_monkey_1 = require("fs-monkey");
exports.default = async (...args) => {
    const { blobStore } = await import('./cache.cjs');
    async function readFileFallbackBlobStore(...args) {
        const [path, options] = args;
        try {
            // Attempt to read from the disk
            // important to use the `import * as fs from 'fs'` here to not end up in a endless loop
            return await fs.readFile(path, options);
        }
        catch (error) {
            // only try to get .html files from the blob store
            if (typeof path === 'string' && path.endsWith('.html')) {
                const blobKey = (0, path_1.relative)((0, path_1.join)(process.cwd(), '.next'), path);
                const file = await blobStore.get(blobKey);
                if (file !== null) {
                    return file;
                }
            }
            throw error;
        }
    }
    // patch the file system for fs.promises with operations to fallback on the blob store
    (0, fs_monkey_1.patchFs)({
        readFile: readFileFallbackBlobStore,
    }, require('fs').promises);
    const { getRequestHandlers } = await import('next/dist/server/lib/start-server.js');
    return getRequestHandlers(...args);
};
